## quassel 0.14.0

=== data/CMakeLists.txt ===
if (BUILD_GUI)
    if (WITH_KF5)
        install(FILES quassel.notifyrc DESTINATION ${CMAKE_INSTALL_KNOTIFY5RCDIR})
    endif()

    if (UNIX AND NOT APPLE)
        if (WANT_QTCLIENT)
            install(FILES quasselclient.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
        endif()

        if (WANT_MONO)
            install(FILES quassel.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
        endif()
    endif()

    if (EMBED_DATA)
        quassel_add_resource(Data PREFIX data PATTERNS
            networks.ini
            stylesheets/default.qss
        )
    else()
        install(FILES networks.ini DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel)
        install(DIRECTORY stylesheets DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel)
    endif()

    if (NOT WIN32)
        install(DIRECTORY scripts DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel USE_SOURCE_PERMISSIONS)
    endif()
endif()

=== icons/CMakeLists.txt ===
# Install icons

if (WANT_MONO OR WANT_QTCLIENT)
    if (NOT WITH_BUNDLED_ICONS AND NOT WITH_OXYGEN_ICONS)
        message(WARNING "Not including bundled icon themes. Ensure that the Breeze or Oxygen icon theme is installed!")
    endif()

    set(BUNDLED_ICON_THEME_DIR ${CMAKE_SOURCE_DIR}/3rdparty/icons)

    # Always embed a hicolor fallback containing the most important (e.g. tray) icons.
    # The .qrc contains aliases, so it's best to keep this manually written rather than autogenerated.
    quassel_add_module(Resource::HicolorIcons STATIC)
    target_sources(${TARGET} PRIVATE hicolor_icons.qrc)
    set_target_properties(${TARGET} PROPERTIES AUTOMOC OFF AUTOUIC OFF)

    if (EMBED_DATA)
        # Always embed quassel-specific icons
        message(STATUS "Embedding Quassel-specific icons")
        set(patterns breeze*/*.svg)
        if (WITH_OXYGEN_ICONS)
            list(APPEND patterns oxygen/*.png)
        endif()
        quassel_add_resource(Icons PREFIX icons PATTERNS ${patterns})

        if (WITH_BUNDLED_ICONS)
            message(STATUS "Embedding bundled Breeze icon theme")
            set(patterns breeze*/*.svg breeze*/index.theme)
            if (WITH_OXYGEN_ICONS)
                message(STATUS "Embedding bundled Oxygen icon theme")
                list(APPEND patterns oxygen/*.png oxygen/index.theme)
            endif()
        endif()
        quassel_add_resource(IconThemes PREFIX icons PATTERNS ${patterns} BASEDIR ${BUNDLED_ICON_THEME_DIR})

    else()
        # Always install quassel-specific icons
        install(DIRECTORY breeze breeze-dark DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        if (WITH_OXYGEN_ICONS)
            install(DIRECTORY oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        endif()

        # Install bundled icon themes into our data dir (instead of CMAKE_INSTALL_ICONDIR) to avoid conflicts
        # with themes provided by the system
        if (WITH_BUNDLED_ICONS)
            message(STATUS "Installing bundled Breeze icon theme")
            install(DIRECTORY   ${BUNDLED_ICON_THEME_DIR}/breeze
                                ${BUNDLED_ICON_THEME_DIR}/breeze-dark
                    DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons
            )
            if (WITH_OXYGEN_ICONS)
                message(STATUS "Installing bundled Oxygen icon theme")
                install(DIRECTORY ${BUNDLED_ICON_THEME_DIR}/oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
            endif()
        endif()
    endif()

    # Application icon
    if (HAVE_KDE OR (UNIX AND NOT APPLE))
        # hicolor contains the application icon in all relevant sizes
        install(DIRECTORY hicolor DESTINATION ${CMAKE_INSTALL_ICONDIR})

        if (Qt5Core_VERSION VERSION_LESS 5.5.0)
            # Qt < 5.5 doesn't seem to correctly load icons from injected themes
            # Install Quassel-specific ones from Oxygen into hicolor as fallback
            install(DIRECTORY oxygen/ DESTINATION ${CMAKE_INSTALL_ICONDIR}/hicolor)
        endif()
    endif()
endif()

=== pics/CMakeLists.txt ===
# pics/ contains non-themed icons and other graphical resources

if (WANT_MONO OR WANT_QTCLIENT)
    quassel_add_resource(Pics PREFIX pics PATTERNS
        kde-vdg.png
        quassel-64.svg
        quassel-eye.png
        quassel-logo.png
        quassel-oxygen-32.png
        qt-logo-32.png
    )
endif()

# On macOS, the individual icons should be converted into an iconset
add_custom_command(
    COMMENT "Creating iconset for macOS"
    OUTPUT quassel.icns
    COMMAND iconutil ARGS -c icns -o ${CMAKE_CURRENT_BINARY_DIR}/quassel.icns ${CMAKE_CURRENT_SOURCE_DIR}/quassel.iconset
)
add_custom_target(MacOsIcons DEPENDS quassel.icns)

=== po/CMakeLists.txt ===
# Generate translations
# The LINGUAS environment variable can be used to limit the set of supported languages

# Generate a .ts file from a .po file
function(generate_ts basename)
    set(pofile ${CMAKE_CURRENT_SOURCE_DIR}/${basename}.po)
    set(tsfile ${CMAKE_CURRENT_BINARY_DIR}/${basename}.ts)

    add_custom_command(VERBATIM
        COMMENT "Preparing translation for language '${basename}'"
        COMMAND $<TARGET_FILE:Qt5::lconvert> -i ${pofile} -target-language ${basename} -of ts -o ${tsfile}
        DEPENDS ${pofile}
        OUTPUT  ${tsfile}
    )
endfunction()

# Clear variables just in case
set(tsfiles )
set(qmfiles )
set(linguas )

if (TARGET Qt5::lconvert)
    # LINGUAS can be used to limit the included languages
    set(LINGUAS "$ENV{LINGUAS}")
    # Normalize and convert into list
    string(REGEX REPLACE "[ \t,;]+" ";" LINGUAS "${LINGUAS}")

    # We support xx.po and xx_YY.po, and additionally translations for qt using qt_xx.po or qt_xx_YY.po
    file(GLOB pofiles *.po)
    foreach(pofile ${pofiles})
        get_filename_component(basename ${pofile} NAME_WE)
        # CMake can't use MATCH to get the second catch...
        string(REGEX REPLACE "(qt_)?([a-zA-Z]+)(_.+)?$" "\\2" lang ${basename})
        # Test if we want this language
        set(idx 0)
        if(LINGUAS)
            list(FIND LINGUAS ${lang} idx)  # idx will be -1 if ${lang} is not found in LINGUAS
        endif()
        if(idx GREATER -1)
            generate_ts(${basename})
            list(APPEND tsfiles ${CMAKE_CURRENT_BINARY_DIR}/${basename}.ts)
            list(APPEND qmfiles ${CMAKE_CURRENT_BINARY_DIR}/${basename}.qm)
            list(APPEND linguas ${lang})
        endif()
    endforeach()

    if (tsfiles)
        # Synchronize the (possibly outdated) .ts files with the current source tree
        add_custom_command(VERBATIM
            COMMENT "Syncing translations"
            COMMAND $<TARGET_FILE:Qt5::lupdate> -silent ${CMAKE_SOURCE_DIR}/src -ts ${tsfiles}
            COMMAND ${CMAKE_COMMAND} -E touch tsfiles.done
            DEPENDS ${tsfiles}
            OUTPUT tsfiles.done
        )

        # Generate the final translation files (.qm) for use by Qt
        add_custom_command(VERBATIM
            COMMENT "Compressing translations"
            COMMAND $<TARGET_FILE:Qt5::lrelease> -silent ${tsfiles}
            DEPENDS tsfiles.done
            OUTPUT ${qmfiles}
        )

        # Curate the language list and give diagnostic output
        list(REMOVE_DUPLICATES linguas)
        list(SORT linguas)
        string(REPLACE ";" ", " linguas_string "${linguas}")
        message(STATUS "Enabling translations for: ${linguas_string}")
    else()
        message(STATUS "No translations enabled")
    endif()
else()
    message(WARNING "Qt Linguist Tools not found, you won't have translations!")
endif()

# Always generate translations
add_custom_target(translations ALL DEPENDS ${qmfiles})

if (EMBED_DATA)
    quassel_add_resource(I18n PREFIX i18n BASEDIR ${CMAKE_CURRENT_BINARY_DIR} PATTERNS ${qmfiles} DEPENDS translations)
else()
    install(FILES ${qmfiles} DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/translations)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(common)
if (BUILD_CORE)
    add_subdirectory(core)
endif()
if (BUILD_GUI)
    add_subdirectory(client)
    add_subdirectory(uisupport)
    add_subdirectory(qtui)
endif()

if (BUILD_TESTING)
    add_subdirectory(test)
endif()

add_subdirectory(main)

=== tests/CMakeLists.txt ===
add_subdirectory(common)
if (BUILD_CORE)
    add_subdirectory(core)
endif()

=== src/client/CMakeLists.txt ===
quassel_add_module(Client EXPORT)

target_sources(${TARGET} PRIVATE
    abstractmessageprocessor.cpp
    backlogrequester.cpp
    backlogsettings.cpp
    buffermodel.cpp
    buffersettings.cpp
    bufferviewoverlay.cpp
    client.cpp
    clientaliasmanager.cpp
    clientauthhandler.cpp
    clientbacklogmanager.cpp
    clientbufferviewconfig.cpp
    clientbufferviewmanager.cpp
    clientidentity.cpp
    clientignorelistmanager.cpp
    clientirclisthelper.cpp
    clientsettings.cpp
    clienttransfer.cpp
    clienttransfermanager.cpp
    clientuserinputhandler.cpp
    coreaccount.cpp
    coreaccountmodel.cpp
    coreconnection.cpp
    execwrapper.cpp
    irclistmodel.cpp
    messagefilter.cpp
    messagemodel.cpp
    networkmodel.cpp
    selectionmodelsynchronizer.cpp
    transfermodel.cpp
    treemodel.cpp

    # needed for automoc
    abstractui.h
)

target_link_libraries(${TARGET}
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Network
        Qt5::Widgets  # QAbstractItemView in BufferModel
        Quassel::Common
)

if (EMBED_DATA)
    set_property(SOURCE client.cpp APPEND PROPERTY COMPILE_DEFINITIONS EMBED_DATA)
endif()

target_link_if_exists(${TARGET} PUBLIC Quassel::Resource::Data)

=== src/common/CMakeLists.txt ===
quassel_add_module(Common EXPORT)

target_sources(${TARGET} PRIVATE
    abstractsignalwatcher.h
    aliasmanager.cpp
    authhandler.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    compressor.cpp
    coreinfo.cpp
    ctcpevent.cpp
    dccconfig.cpp
    event.cpp
    eventmanager.cpp
    expressionmatch.cpp
    funchelpers.h
    highlightrulemanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    internalpeer.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircdecoder.cpp
    ircencoder.cpp
    irctag.cpp
    irctags.h
    ircuser.cpp
    logger.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    nickhighlightmatcher.cpp
    peer.cpp
    peerfactory.cpp
    presetnetworks.cpp
    quassel.cpp
    proxyline.cpp
    remotepeer.cpp
    settings.cpp
    signalproxy.cpp
    singleton.h
    syncableobject.cpp
    transfer.cpp
    transfermanager.cpp
    types.cpp
    util.cpp

    serializers/serializers.cpp

    protocols/datastream/datastreampeer.cpp
    protocols/legacy/legacypeer.cpp

    # needed for automoc
    irccap.h
    protocol.h
)

# Needed for finding the generated version.h
target_include_directories(${TARGET} PRIVATE ${CMAKE_BINARY_DIR})

target_link_libraries(${TARGET} PUBLIC
    ${CMAKE_DL_LIBS}
    Boost::boost
    Qt5::Core
    Qt5::Network
    ZLIB::ZLIB
)

if (EMBED_DATA)
    set_property(SOURCE quassel.cpp APPEND PROPERTY COMPILE_DEFINITIONS EMBED_DATA)
endif()

if (HAVE_SYSLOG)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_SYSLOG)
endif()

if (WIN32)
    target_sources(${TARGET} PRIVATE logbacktrace_win.cpp windowssignalwatcher.cpp)
else()
    if (Backtrace_FOUND)
        configure_file(backtrace_config.h.in backtrace_config.h)
        target_include_directories(${TARGET} PRIVATE ${Backtrace_INCLUDE_DIRS})
        target_link_libraries(${TARGET} PRIVATE ${Backtrace_LIBRARIES})
        set_property(SOURCE logbacktrace_unix.cpp posixsignalwatcher.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_BACKTRACE)
    endif()
    target_sources(${TARGET} PRIVATE logbacktrace_unix.cpp posixsignalwatcher.cpp)
endif()

if (APPLE)
    target_sources(${TARGET} PRIVATE mac_utils.cpp)
    target_link_libraries(${TARGET} PUBLIC "-framework CoreServices" "-framework CoreFoundation")
endif()

target_link_if_exists(${TARGET} PUBLIC Quassel::Resource::I18n)

=== src/core/CMakeLists.txt ===
quassel_add_module(Core EXPORT)

target_sources(${TARGET} PRIVATE
    abstractsqlstorage.cpp
    authenticator.cpp
    core.cpp
    corealiasmanager.cpp
    coreapplication.cpp
    coreauthhandler.cpp
    corebacklogmanager.cpp
    corebasichandler.cpp
    corebuffersyncer.cpp
    corebufferviewconfig.cpp
    corebufferviewmanager.cpp
    coredccconfig.cpp
    corehighlightrulemanager.cpp
    coreidentity.cpp
    coreignorelistmanager.cpp
    coreircchannel.cpp
    coreirclisthelper.cpp
    coreircuser.cpp
    corenetwork.cpp
    corenetworkconfig.cpp
    coresession.cpp
    coresessioneventprocessor.cpp
    coresettings.cpp
    coretransfer.cpp
    coretransfermanager.cpp
    coreuserinputhandler.cpp
    coreusersettings.cpp
    ctcpparser.cpp
    eventstringifier.cpp
    identserver.cpp
    ircparser.cpp
    ldapescaper.cpp
    metricsserver.cpp
    netsplit.cpp
    oidentdconfiggenerator.cpp
    postgresqlstorage.cpp
    sessionthread.cpp
    sqlauthenticator.cpp
    sqlitestorage.cpp
    sslserver.cpp
    storage.cpp

    # needed for automoc
    coreeventmanager.h
)

target_link_libraries(${TARGET}
    PUBLIC
        Qt5::Core
        Qt5::Network
        Qt5::Sql
        Quassel::Common
)

if (HAVE_UMASK)
    set_property(SOURCE oidentdconfiggenerator.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_UMASK)
endif()

if (Ldap_FOUND)
    target_sources(${TARGET} PRIVATE ldapauthenticator.cpp)
    target_link_libraries(${TARGET} PRIVATE Ldap::Ldap)
    set_property(SOURCE core.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_LDAP)
endif()

if (Qca-qt5_FOUND)
    target_sources(${TARGET} PRIVATE cipher.cpp keyevent.cpp)
    target_link_libraries(${TARGET} PUBLIC qca-qt5)
    target_compile_definitions(${TARGET} PUBLIC -DHAVE_QCA2)
endif()

quassel_add_resource(Sql PATTERNS SQL/*.sql)
target_link_libraries(${TARGET} PUBLIC Quassel::Resource::Sql)

=== src/main/CMakeLists.txt ===
if (HAVE_UMASK)
    set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_UMASK)
endif()

if (WITH_BUNDLED_ICONS)
    set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_DEFINITIONS WITH_BUNDLED_ICONS)
endif()

# Windows icon resource
if(WIN32)
    if(MINGW)
        find_program(WINDRES_EXECUTABLE NAMES windres)
        if(WINDRES_EXECUTABLE)
            exec_program(windres
                ARGS "-i ${CMAKE_SOURCE_DIR}/pics/win32.rc"
                     "-o ${CMAKE_CURRENT_BINARY_DIR}/win32.o"
                     "--include-dir=${CMAKE_SOURCE_DIR}/pics"
                )
            set(WIN_RC ${CMAKE_CURRENT_BINARY_DIR}/win32.o)
        endif()
    else()
        set(WIN_RC ${CMAKE_SOURCE_DIR}/pics/win32.rc)
    endif()
endif()

# Build the executables
if (WANT_CORE)
    quassel_add_executable(quasselcore COMPONENT Core SOURCES main.cpp ${WIN_RC} LIBRARIES Qt5::Core Quassel::Core)
endif()

if (WANT_QTCLIENT)
    set(libs Qt5::Core Qt5::Gui Quassel::QtUi)
    if (WITH_KDE)
        list(APPEND libs KF5::CoreAddons)
    endif()
    quassel_add_executable(quasselclient COMPONENT Client SOURCES main.cpp ${WIN_RC} LIBRARIES ${libs})
endif()

if (WANT_MONO)
    set(libs Qt5::Core Qt5::Gui Quassel::Core Quassel::QtUi)
    if (WITH_KDE)
        list(APPEND libs KF5::CoreAddons)
    endif()
    quassel_add_executable(quassel COMPONENT Mono SOURCES main.cpp monoapplication.cpp ${WIN_RC} LIBRARIES ${libs})
endif()

=== src/qtui/CMakeLists.txt ===
quassel_add_module(QtUi EXPORT)

target_sources(${TARGET} PRIVATE
    aboutdlg.cpp
    awaylogfilter.cpp
    awaylogview.cpp
    bufferwidget.cpp
    channellistdlg.cpp
    chatitem.cpp
    chatline.cpp
    chatlinemodel.cpp
    chatlinemodelitem.cpp
    chatmonitorfilter.cpp
    chatmonitorview.cpp
    chatscene.cpp
    chatview.cpp
    chatviewsearchbar.cpp
    chatviewsearchcontroller.cpp
    chatviewsettings.cpp
    columnhandleitem.cpp
    coreconfigwizard.cpp
    coreconnectdlg.cpp
    coreconnectionstatuswidget.cpp
    coreinfodlg.cpp
    coresessionwidget.cpp
    debugbufferviewoverlay.cpp
    debuglogdlg.cpp
    debugmessagemodelfilter.cpp
    inputwidget.cpp
    ircconnectionwizard.cpp
    legacysystemtray.cpp
    mainpage.cpp
    mainwin.cpp
    markerlineitem.cpp
    msgprocessorstatuswidget.cpp
    nicklistwidget.cpp
    passwordchangedlg.cpp
    qtui.cpp
    qtuiapplication.cpp
    qtuimessageprocessor.cpp
    qtuisettings.cpp
    qtuistyle.cpp
    receivefiledlg.cpp
    resourcetreedlg.cpp
    settingsdlg.cpp
    settingspagedlg.cpp
    simplenetworkeditor.cpp
    sslinfodlg.cpp
    systemtray.cpp
    systrayanimationnotificationbackend.cpp
    systraynotificationbackend.cpp
    taskbarnotificationbackend.cpp
    titlesetter.cpp
    topicwidget.cpp
    verticaldock.cpp
    webpreviewitem.cpp

    # UI files
    aboutdlg.ui
    bufferviewwidget.ui
    bufferwidget.ui
    channellistdlg.ui
    chatviewsearchbar.ui
    coreconfigwizardintropage.ui
    coreconfigwizardauthenticationselectionpage.ui
    coreconfigwizardadminuserpage.ui
    coreconfigwizardstorageselectionpage.ui
    coreconfigwizardsyncpage.ui
    coreconnectauthdlg.ui
    coreconnectionstatuswidget.ui
    coreinfodlg.ui
    coresessionwidget.ui
    debugbufferviewoverlay.ui
    debuglogdlg.ui
    inputwidget.ui
    msgprocessorstatuswidget.ui
    nicklistwidget.ui
    passwordchangedlg.ui
    receivefiledlg.ui
    resourcetreedlg.ui
    settingsdlg.ui
    settingspagedlg.ui
    simplenetworkeditor.ui
    sslinfodlg.ui
    systrayanimationconfigwidget.ui
    topicwidget.ui
)

# Handle settingspages
target_include_directories(${TARGET} PRIVATE settingspages)
include(settingspages/settingspages.cmake)
foreach(page ${SETTINGSPAGES})
    target_sources(${TARGET} PRIVATE
        settingspages/${page}settingspage.cpp
        settingspages/${page}settingspage.ui
    )
endforeach()
foreach(src ${SP_SOURCES})
    target_sources(${TARGET} PRIVATE settingspages/${src})
endforeach()
foreach(form ${SP_FORMS})
    target_sources(${TARGET} PRIVATE settingspages/${form})
endforeach()

target_link_libraries(${TARGET}
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Network
        Qt5::Widgets
        Quassel::UiSupport
        Quassel::Client
        Quassel::Common
)

if (WITH_KDE)
    target_sources(${TARGET} PRIVATE knotificationbackend.cpp)
    target_link_libraries(${TARGET} PUBLIC
        KF5::ConfigWidgets
        KF5::Notifications
        KF5::NotifyConfig
        KF5::WidgetsAddons
        KF5::XmlGui
    )
endif()

if (KF5Sonnet_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_SONNET)
    target_sources(${TARGET} PRIVATE settingspages/sonnetsettingspage.cpp)
    target_link_libraries(${TARGET} PRIVATE KF5::SonnetUi)
endif()

if (Qt5Multimedia_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_QTMULTIMEDIA)
    target_sources(${TARGET} PRIVATE
        qtmultimedianotificationbackend.cpp
        qtmultimedianotificationconfigwidget.ui
    )
    target_link_libraries(${TARGET} PRIVATE Qt5::Multimedia)
endif()

if (Qt5DBus_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_DBUS)
    target_link_libraries(${TARGET} PRIVATE Qt5::DBus)
    if (dbusmenu-qt5_FOUND)
        target_compile_definitions(${TARGET} PRIVATE -DHAVE_DBUSMENU)
        target_link_libraries(${TARGET} PRIVATE dbusmenu-qt5)
    endif()

    qt5_add_dbus_interface(DBUS_SOURCES ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt5_add_dbus_interface(DBUS_SOURCES ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt5_add_dbus_adaptor  (DBUS_SOURCES ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)

    target_sources(${TARGET} PRIVATE
        dockmanagernotificationbackend.cpp
        statusnotifieritem.cpp
        statusnotifieritemdbus.cpp
        ${DBUS_SOURCES}
    )
endif()

if (HAVE_WEBKIT)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_WEBKIT)
    target_link_libraries(${TARGET} PRIVATE
        Qt5::WebKit
        Qt5::WebKitWidgets
    )
endif()

if (HAVE_WEBENGINE)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_WEBENGINE)
    target_link_libraries(${TARGET} PRIVATE
        Qt5::WebEngine
        Qt5::WebEngineWidgets)
endif()

if (LibsnoreQt5_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_LIBSNORE)
    target_sources(${TARGET} PRIVATE
        snorenotificationbackend.cpp
        snorentificationconfigwidget.ui
    )
    target_link_libraries(${TARGET} PRIVATE Snore::Libsnore Snore::LibsnoreSettings)
endif()

if (WITH_NOTIFICATION_CENTER)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_NOTIFICATION_CENTER)
    target_sources(${TARGET} PRIVATE osxnotificationbackend.mm)
    target_link_libraries(${TARGET} PRIVATE "/System/Library/Frameworks/Foundation.framework")
endif()

if (WITH_OXYGEN_ICONS)
    set_property(SOURCE qtui.cpp APPEND PROPERTY COMPILE_DEFINITIONS WITH_OXYGEN_ICONS)
endif()

=== src/uisupport/CMakeLists.txt ===
quassel_add_module(UiSupport EXPORT)

target_sources(${TARGET} PRIVATE
    aboutdata.cpp
    abstractbuffercontainer.cpp
    abstractitemview.cpp
    action.cpp
    actioncollection.cpp
    bufferhotlistfilter.cpp
    bufferview.cpp
    bufferviewfilter.cpp
    bufferviewoverlayfilter.cpp
    clearablelineedit.cpp
    clickable.cpp
    clickablelabel.cpp
    colorbutton.cpp
    contextmenuactionprovider.cpp
    flatproxymodel.cpp
    fontselector.cpp
    graphicalui.cpp
    icon.cpp
    multilineedit.cpp
    networkmodelcontroller.cpp
    nickview.cpp
    nickviewfilter.cpp
    qssparser.cpp
    resizingstackedwidget.cpp
    settingspage.cpp
    styledlabel.cpp
    tabcompleter.cpp
    toolbaractionprovider.cpp
    treeviewtouch.cpp
    uisettings.cpp
    uistyle.cpp
    widgethelpers.h

    # needed for automoc
    abstractnotificationbackend.h
)

target_link_libraries(${TARGET}
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Network
        Qt5::Widgets
        Quassel::Client
        Quassel::Common
)

if (EMBED_DATA)
    set_property(SOURCE graphicalui.cpp APPEND PROPERTY COMPILE_DEFINITIONS EMBED_DATA)
endif()

if (WITH_KF5)
    target_link_libraries(${TARGET}
        PUBLIC
            KF5::CoreAddons
            KF5::TextWidgets
            KF5::XmlGui
    )
endif()

if (KF5Sonnet_FOUND)
    target_link_libraries(${TARGET} PRIVATE KF5::SonnetUi)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_SONNET)
endif()

target_link_if_exists(${TARGET}
    PUBLIC
        Quassel::Resource::HicolorIcons
        Quassel::Resource::Icons
        Quassel::Resource::IconThemes
        Quassel::Resource::Pics
)

=== debian/changelog ===
quassel (1:0.14.0-3ubuntu2) questing; urgency=medium

  * Re-enable building for riscv64 (LP: #2121427)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Tue, 26 Aug 2025 00:07:04 +0200

quassel (1:0.14.0-3ubuntu1) questing; urgency=medium

  * Merge with Debian unstable. (LP: #2115232)  Remaining changes:
    - Add d/patches/01_change_default_libera_channel.patch. Replaces default
    #quassel channel with #ubuntu.
    - Remove d/patches/01_default_network_channel.patch. Superseded by the
    previous libera channel patch.
    - Update apparmor profile to allow running in lxd.
    - Limit the build to only those architectures supported by QtWebEngine 5
  * Drop Changes:
    - Drop build-dependency on qtwebkit. (Closes: 1098332)

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Mon, 23 Jun 2025 21:24:23 -0500

quassel (1:0.14.0-3) unstable; urgency=medium

  * Team upload.
  * Drop build-dependency on qtwebkit. (Closes: #1098332)

 -- Felix Geyer <fgeyer@debian.org>  Fri, 21 Feb 2025 18:24:24 +0100

quassel (1:0.14.0-2ubuntu4) plucky; urgency=medium

  * Remove the build dependency on QtWebKit 5, and limit the build to only
    those architectures supported by QtWebEngine 5 (LP: #2100639).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 04 Mar 2025 23:12:53 -0600

quassel (1:0.14.0-2ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:09:03 +0000

quassel (1:0.14.0-2ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:57:50 +0000

quassel (1:0.14.0-2ubuntu1) mantic; urgency=medium

  * Merge from debian unstable. Remaining changes:
    - Add d/patches/01_change_default_libera_channel.patch. Replaces default
      #quassel channel with #ubuntu.
    - Remove d/patches/01_default_network_channel.patch. Superseded by the
      previous libera channel patch.
    - Update apparmor profile to allow running in lxd.

 -- Rik Mills <rikmills@kde.org>  Sun, 23 Jul 2023 18:41:56 +0100

quassel (1:0.14.0-2) unstable; urgency=medium

  * Team upload.

  [ Christian Göttsche ]
  * Update blhc configuration

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 12 to 13.
    + debian/rules: Drop --fail-missing argument to dh_missing, which is now the
      default.
  * Fix day-of-week for changelog entries 0.5.1-2, 0.3.1+dfsg-2, 0.3.1+dfsg-1.
  * Update standards version to 4.6.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Adrian Bunk ]
  * qtwebengine5-dev is now available on mips64el.

  [ Pino Toscano ]
  * Update standards version to 4.6.2, no changes needed.
  * Drop patch 02_script_interpreter_path.patch, as now dh_perl rewrites perl
    shebangs.
  * Stop using qtwebengine5-dev on mipsel, as it will be removed soon from
    that architecture.
  * Switch the list of architectures for libqt5webkit5-dev to be a negated
    version of the ones for qtwebengine5-dev, so it is easier to maintain.
  * Remove inactive Uploaders.
  * Drop the obsolete lsb-base dependency.
  * Use chrpath to drop the extra RPATH set in binaries.
  * Remove the custom inxi script directly during dh_auto_install, rather than
    with extra checks during dh_install.
  * Use execute_after_dh_install to avoid invoking dh_install manually.
  * Use the ${perl:Depends} substvar in quassel-data.
  * CI: do not consider lintian warnings as fatal.

 -- Pino Toscano <pino@debian.org>  Sat, 22 Jul 2023 09:18:22 +0200

quassel (1:0.14.0-1ubuntu5) lunar; urgency=medium

  * No-change rebuild against libldap-2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Dec 2022 19:54:34 +0000

quassel (1:0.14.0-1ubuntu4) kinetic; urgency=medium

  * Remove d/patches/01_default_network_channel.patch
    - Superseded
  * Add d/patches/01_change_default_libera_channel.patch
    - Replaces default #quassel channel with #ubuntu (LP: #1980687)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 06 Jul 2022 19:41:57 -0700

quassel (1:0.14.0-1ubuntu3) kinetic; urgency=medium

  * d/patches/01_default_network_channel.patch
    - Fix network name from DebianIRC to UbuntuIRC (LP: #1980687)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 06 Jul 2022 10:43:03 -0700

quassel (1:0.14.0-1ubuntu2) kinetic; urgency=medium

  * d/patches/01_default_network_channel.patch
    - Update to point to #ubuntu on irc.libera.chat by default (LP: #1980687)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 04 Jul 2022 11:26:24 -0700

quassel (1:0.14.0-1ubuntu1) kinetic; urgency=medium

  * d/usr.bin.quasselcore:
    - Update apparmor profile to allow running in lxd (LP: #1814302)

 -- Dave Jones <dave.jones@canonical.com>  Sun, 12 Jun 2022 20:52:19 +0100

quassel (1:0.14.0-1build1) jammy; urgency=medium

  * No-change rebuild to update maintainer scripts, see LP: 1959054

 -- Dave Jones <dave.jones@canonical.com>  Wed, 16 Feb 2022 17:28:49 +0000

quassel (1:0.14.0-1) unstable; urgency=medium

  * Update d/watch to version 4 and to point to the new upstream location
  * Delete d/patches/qt514 and update d/p/series due to new release
  * New upstream release
    - Refresh patches
  * Add libboost-dev to build-depends
  * Update d/quassel-data.install for current install locations
  * Update d/rules to not build shared library: ENABLE_SHARED=OFF
  * Add libldap2-dev to build-depends to enable support for LDAP
    authentication
  * Add NEWS entry about new database and config file formats
  * Update quasselcore.1 for 0.14.0

 -- Scott Kitterman <scott@kitterman.com>  Wed, 12 Jan 2022 17:29:46 -0500

=== debian/control ===
Source: quassel
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Scott Kitterman <scott@kitterman.com>,
Build-Depends: debhelper-compat (= 13),
               dh-apparmor,
               chrpath,
               cmake,
               libqca-qt5-2-dev,
               zlib1g-dev,
               qttools5-dev-tools,
               qttools5-dev,
               qtscript5-dev,
               qtmultimedia5-dev,
               libboost-dev,
               libldap2-dev,
               libphonon4qt5-dev,
               libphonon4qt5experimental-dev,
               libdbusmenu-qt5-dev,
               qtwebengine5-dev [amd64 arm64 armhf i386 mips64el],
               extra-cmake-modules,
               libkf5textwidgets-dev,
               libkf5coreaddons-dev,
               libkf5xmlgui-dev,
               libkf5notifications-dev,
               libkf5notifyconfig-dev,
               libkf5widgetsaddons-dev,
               libssl-dev
Homepage: https://www.quassel-irc.org/
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/quassel.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/quassel

Package: quassel-core
Architecture: amd64 arm64 armhf i386 mips64el riscv64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt5sql5-sqlite, openssl
Recommends: ca-certificates
Suggests: libqt5sql5-psql
Description: distributed IRC client - core component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the core component.

Package: quassel-client
Architecture: amd64 arm64 armhf i386 mips64el riscv64
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data (= ${source:Version}), default-dbus-session-bus | dbus-session-bus
Breaks: quassel-client-kde4 (<< 0.12.2)
Replaces: quassel-client-kde4 (<< 0.12.2)
Description: distributed IRC client - client component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component.

Package: quassel
Architecture: amd64 arm64 armhf i386 mips64el riscv64
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite, quassel-data (= ${source:Version}), default-dbus-session-bus | dbus-session-bus
Recommends: ca-certificates
Breaks: quassel-kde4 (<< 0.12.2)
Replaces: quassel-kde4 (<< 0.12.2)
Description: distributed IRC client - monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client. It contains both core and
 client and can be used like a traditional IRC client, without requiring an
 external core.

Package: quassel-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: breeze-icon-theme | oxygen-icon-theme
Suggests: inxi
Conflicts: quassel-data-kde4
Multi-Arch: foreign
Description: distributed IRC client - shared data
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the Quassel client packages.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_OXYGEN_ICONS=ON -DWITH_BUNDLED_ICONS=OFF -DUSE_QT5=ON -DWITH_KDE=ON -DENABLE_SHARED=OFF

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: .*/CMakeCXXCompilerABI.cpp.*"

execute_after_dh_auto_install:
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/*
	# replace inxi with a symlink
	rm $(CURDIR)/debian/tmp/usr/share/quassel/scripts/inxi

execute_after_dh_install:
	dh_apparmor -pquassel-core --profile-name=usr.bin.quasselcore

override_dh_installinit:
	dh_installinit --no-stop-on-upgrade --no-restart-after-upgrade --error-handler=exit --name=quasselcore

override_dh_installsystemd:
	dh_installsystemd --no-stop-on-upgrade --no-restart-after-upgrade --name=quasselcore

=== debian/watch ===
version=4
https://www.quassel-irc.org/pub/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## quassel 0.14.0-1ubuntu0.22.04.4%2B11.0trisquel3

=== debian/changelog ===
quassel (1:0.14.0-1ubuntu0.22.04.4+11.0trisquel3) aramo; urgency=medium

  * Change default channel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 26 Jul 2022 19:24:57 +0000

quassel (1:0.14.0-1ubuntu0.22.04.4) jammy; urgency=medium

  * Remove d/patches/01_default_network_channel.patch
    - Superseded
  * Add d/patches/01_change_default_libera_channel.patch
    - Replaces default #quassel channel with #ubuntu (LP: #1980687)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 06 Jul 2022 19:53:53 -0700

quassel (1:0.14.0-1ubuntu0.22.04.3) jammy; urgency=medium

  * d/patches/01_default_network_channel.patch
    - Fix network name from DebianIRC to UbuntuIRC (LP: #1980687)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 06 Jul 2022 10:53:29 -0700

quassel (1:0.14.0-1ubuntu0.22.04.2) jammy; urgency=medium

  * d/patches/01_default_network_channel.patch
    - Update to point to #ubuntu on irc.libera.chat by default (LP: #1980687) 

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 04 Jul 2022 11:48:33 -0700

quassel (1:0.14.0-1ubuntu0.22.04.1) jammy; urgency=medium

  * d/usr.bin.quasselcore:
    - Update apparmor profile to allow running in lxd (LP: #1814302)

 -- Dave Jones <dave.jones@canonical.com>  Sun, 12 Jun 2022 20:52:19 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: quassel
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
-Uploaders: Scott Kitterman <scott@kitterman.com>,
-Build-Depends: debhelper-compat (= 13),
+Uploaders: Thomas Mueller <thomas.mueller@tmit.eu>,
+           Felix Geyer <fgeyer@debian.org>,
+           Scott Kitterman <scott@kitterman.com>
+Build-Depends: debhelper-compat (= 12),
                dh-apparmor,
-               chrpath,
                cmake,
                libqca-qt5-2-dev,
                zlib1g-dev,
@@ -19,7 +20,8 @@
                libphonon4qt5-dev,
                libphonon4qt5experimental-dev,
                libdbusmenu-qt5-dev,
-               qtwebengine5-dev [amd64 arm64 armhf i386 mips64el],
+               qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
+               libqt5webkit5-dev [armel hurd-i386 mips mips64el ppc64el s390x],
                extra-cmake-modules,
                libkf5textwidgets-dev,
                libkf5coreaddons-dev,
@@ -29,14 +31,14 @@
                libkf5widgetsaddons-dev,
                libssl-dev
 Homepage: https://www.quassel-irc.org/
-Standards-Version: 4.6.2
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/quassel.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/quassel
 
 Package: quassel-core
-Architecture: amd64 arm64 armhf i386 mips64el riscv64
+Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt5sql5-sqlite, openssl
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt5sql5-sqlite, lsb-base (>= 3.2-14), openssl
 Recommends: ca-certificates
 Suggests: libqt5sql5-psql
 Description: distributed IRC client - core component
@@ -48,7 +50,7 @@
  This package provides only the core component.
 
 Package: quassel-client
-Architecture: amd64 arm64 armhf i386 mips64el riscv64
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data (= ${source:Version}), default-dbus-session-bus | dbus-session-bus
 Breaks: quassel-client-kde4 (<< 0.12.2)
 Replaces: quassel-client-kde4 (<< 0.12.2)
@@ -61,7 +63,7 @@
  This package provides only the client component.
 
 Package: quassel
-Architecture: amd64 arm64 armhf i386 mips64el riscv64
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite, quassel-data (= ${source:Version}), default-dbus-session-bus | dbus-session-bus
 Recommends: ca-certificates
 Breaks: quassel-kde4 (<< 0.12.2)
@@ -78,7 +80,7 @@
 
 Package: quassel-data
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}
+Depends: ${misc:Depends}
 Recommends: breeze-icon-theme | oxygen-icon-theme
 Suggests: inxi
 Conflicts: quassel-data-kde4
